"""
This module implements the SWAP gate using the Pauli gates
"""

import numpy as np

from jobs.src.a_job import sigma_x, sigma_y, sigma_z


def swap_gate() -> np.ndarray:

    swap_matrix = 1 / 2 * (np.kron(np.identity(2), np.identity(2)) + np.kron(sigma_x(), sigma_x()) +
                           np.kron(sigma_y(), sigma_y()) + np.kron(sigma_z(), sigma_z()))
    return swap_matrix
